=== modified file 'bzrlib/cmdline.py'
--- bzrlib/cmdline.py	2010-02-02 06:04:26 +0000
+++ bzrlib/cmdline.py	2010-02-02 06:30:43 +0000
@@ -124,7 +124,7 @@
 
 
 class Splitter(object):
-    def __init__(self, command_line, single_quotes_allowed=False):
+    def __init__(self, command_line, single_quotes_allowed):
         self.seq = _PushbackSequence(command_line)
         self.allowed_quote_chars = u'"'
         if single_quotes_allowed:
@@ -153,3 +153,7 @@
         if not self.quoted and result == '':
             result = None
         return self.quoted, result
+
+def split(unsplit, single_quotes_allowed=True):
+    splitter = Splitter(unsplit, single_quotes_allowed=single_quotes_allowed)
+    return [arg for quoted, arg in splitter]

=== modified file 'bzrlib/commands.py'
--- bzrlib/commands.py	2010-02-01 00:50:54 +0000
+++ bzrlib/commands.py	2010-02-02 06:30:43 +0000
@@ -41,6 +41,7 @@
 import bzrlib
 from bzrlib import (
     cleanup,
+    cmdline,
     debug,
     errors,
     option,
@@ -895,16 +896,6 @@
     return ret
 
 
-def shlex_split_unicode(unsplit):
-    if sys.platform == "win32":
-        from bzrlib.win32utils import command_line_to_argv
-        return command_line_to_argv(unsplit, wildcard_expansion=False,
-                                    single_quotes_allowed=True)
-    else:
-        import shlex
-        return [u.decode('utf-8') for u in shlex.split(unsplit.encode('utf-8'))]
-
-
 def get_alias(cmd, config=None):
     """Return an expanded alias, or None if no alias exists.
 
@@ -920,7 +911,7 @@
         config = bzrlib.config.GlobalConfig()
     alias = config.get_alias(cmd)
     if (alias):
-        return shlex_split_unicode(alias)
+        return cmdline.split(alias)
     return None
 
 

=== modified file 'bzrlib/diff.py'
--- bzrlib/diff.py	2010-01-20 23:26:31 +0000
+++ bzrlib/diff.py	2010-02-02 06:30:43 +0000
@@ -31,7 +31,7 @@
 from bzrlib import (
     branch as _mod_branch,
     bzrdir,
-    commands,
+    cmdline,
     errors,
     osutils,
     patiencediff,
@@ -683,7 +683,7 @@
     @classmethod
     def from_string(klass, command_string, old_tree, new_tree, to_file,
                     path_encoding='utf-8'):
-        command_template = commands.shlex_split_unicode(command_string)
+        command_template = cmdline.split(command_string)
         if '@' not in command_string:
             command_template.extend(['@old_path', '@new_path'])
         return klass(command_template, old_tree, new_tree, to_file,

=== modified file 'bzrlib/rules.py'
--- bzrlib/rules.py	2009-05-07 05:08:46 +0000
+++ bzrlib/rules.py	2010-02-02 06:30:43 +0000
@@ -21,7 +21,7 @@
 
 from bzrlib import (
     config,
-    commands,
+    cmdline,
     errors,
     globbing,
     osutils,
@@ -81,8 +81,7 @@
         self.pattern_to_section = {}
         for s in sections:
             if s.startswith(FILE_PREFS_PREFIX):
-                file_patterns = commands.shlex_split_unicode(
-                    s[FILE_PREFS_PREFIX_LEN:])
+                file_patterns = cmdline.split(s[FILE_PREFS_PREFIX_LEN:])
                 patterns.extend(file_patterns)
                 for fp in file_patterns:
                     self.pattern_to_section[fp] = s

